import * as React from 'react';
import { Redirect, RouteComponentProps, RouteProps, Route, Switch } from 'react-router-dom';
import { Container, Menu, Sidebar, Segment, Icon, Breadcrumb, Grid, Dropdown } from 'semantic-ui-react';
import { Header } from './Header';
import { Footer } from './Footer';
import { TitleBar } from './TitleBar';
import LeftMenu from './LeftMenu';

import TargetDetail from '../../views/infrastructure/target/Detail';
import ProbeHistory from '../../views/monitoring/probe/History';


export interface Props extends RouteComponentProps<any> {
}
export interface State {
}

export class TargetDetailLayout extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
    };
  }


  public render(): JSX.Element {
    const sub = [
      {
        'name': 'Info',
        'path': `${this.props.location.pathname}`,
      },
      {
        'name': 'History',
        'path': `${this.props.location.pathname}/history`,
      },
    ];
    return (
      <Container fluid>
        <LeftMenu />
        <Segment vertical style={{ margin: '0 0 0 210px', padding: '0' }}>
          <Header />
          <TitleBar title='Target Details' sub={sub} />
          <Switch>
            <Route exact={true} path={`${this.props.match.url}/:id`} component={TargetDetail} />
            <Route exact={true} path={`${this.props.match.url}/:id/history`} component={ProbeHistory} />
          </Switch>
          <Footer />
        </Segment>
      </Container >
    );
  }
}

export default TargetDetailLayout;

