import * as React from 'react';
// import update from 'immutability-helper';

import { Checkbox, Container, Label, Accordion, Icon, List, ListItemProps } from 'semantic-ui-react';


import MetaSensorItemType from '../../api/model/MetaSensorItemType';
import MetaSensorItem from '../../api/model/MetaSensorItem';

import * as Utils from '@overflow/commons/utils/Utils';




export interface SensorItemTreeStateProps {
}

export interface SensorItemTreeDispatchProps {
  onReadAll?(): void;
}


export type SensorItemTreeProps = SensorItemTreeStateProps & SensorItemTreeDispatchProps;


export interface SensorItemTreeState {
  portState: Map<number, boolean>;
}

interface TreeItem {
  metaSensorItemList: MetaSensorItem[];
  metaSensorItemType: MetaSensorItemType;
}

export class SensorItemTree extends React.Component<SensorItemTreeProps, SensorItemTreeState> {

  private itemMap: Map<number, TreeItem>;

  constructor(props: any, context: any) {
    super(props, context);

    this.itemMap = new Map;

    this.state = {
      portState: new Map(),
    };
    this.sortItemMap();

    // fs.readFile('../../../../../dh.json', this.handlJSONFile);
  }

  public sortItemMap(): void {

    SensorJsonData.map((data: any, idx: number) => {
      let sensorItem: MetaSensorItem = data;

      if (this.itemMap.has(sensorItem.metaSensorItemType.id)) {
        this.itemMap.get(sensorItem.metaSensorItemType.id).metaSensorItemList.push(sensorItem);
      } else {
        let item: TreeItem = { metaSensorItemList: null, metaSensorItemType: null };
        item.metaSensorItemList = [];
        item.metaSensorItemList.push(sensorItem);
        item.metaSensorItemType = this.GetMetaSensorItemType(sensorItem.metaSensorItemType.id);
        this.itemMap.set(sensorItem.id, item);
      }
    });
  }

  public ViewSensorItemType(): JSX.Element[] {
    let elems: JSX.Element[] = new Array();
    this.itemMap.forEach((data: TreeItem, key: number) => {
      // this.state.portState[key] = false;
      elems.push(
        <List.Item key={key} >
          <List.Icon name={this.state.portState[key] ? 'chevron up' : 'chevron down'} onClick={() => {

            let newPortState: Map<number, boolean> = new Map(this.state.portState);
            newPortState[key] = true;
            this.setState({ portState: newPortState });

          }} />
          <List.Content>
            <List.Header> <Checkbox label={data.metaSensorItemType.name} />   </List.Header>
            <List.Description>Category</List.Description>
            {this.state.portState[key] ? this.ViewSensorItem(data.metaSensorItemList) : ''}
          </List.Content>
        </List.Item>,
      );
    });

    return elems;
  }

  public ViewSensorItem(metaSensorItemList: MetaSensorItem[]): JSX.Element[] {
    let elems: JSX.Element[] = new Array();
    metaSensorItemList.map((item: MetaSensorItem, idx: number) => {
      elems.push(
        <List.List key={idx * 1000}>
          <List.Item>
            <List.Icon name='file' />
            <List.Content>
              <List.Header> <Checkbox label={item.name} /></List.Header>
              <List.Description>Sensor Item</List.Description>
            </List.Content>
          </List.Item>
        </List.List>,
      );
    });

    return elems;
  }

  public render(): JSX.Element {
    return (
      <Container>
        <List selection>
          {this.ViewSensorItemType()}
        </List>
      </Container>
    );
  }

  private GetMetaSensorItemType(id: number): MetaSensorItemType {

    for (let i: number = 0; i < SensorTypeJsonData.length; ++i) {
      let msit: MetaSensorItemType = SensorTypeJsonData[i];
      if (msit.id === id) {
        return msit;
      }
    }
    return null;
    // SensorTypeJsonData.map((data: any, idx: number) => {
    //   let msit: MetaSensorItemType = data;
    //   if (msit.id === id) {
    //     return msit;
    //   }
    //   return null;
    // });
    // return null;
  }

}

const SensorTypeJsonData: any = [
  {
    'id': 1,
    'create_date': '2017-06-26T10:49:39Z',
    'description': 'CPU blah blah blah',
    'name': 'CPU',
  },
  {
    'id': 2,
    'create_date': '2017-06-26T10:49:39Z',
    'description': 'MEMORY blah blah blah',
    'name': 'MEMORY',
  },
  {
    'id': 3,
    'create_date': '2017-06-26T10:49:39Z',
    'description': 'DISK blah blah blah',
    'name': 'DISK',
  },
];

const SensorJsonData = [
  {
    'id': 1,
    'create_date': '2017-06-26T11:10:08Z',
    'key': 'cpu.usage',
    'name': 'CPU USAGE',
    'metaSensorItemType': {
      'id': 1,
    },
  },
  {
    'id': 2,
    'create_date': '2017-06-26T11:10:08Z',
    'key': 'cpu.free',
    'name': 'CPU FREE',
    'metaSensorItemType': {
      'id': 1,
    },
  },
  {
    'id': 3,
    'create_date': '2017-06-26T11:10:08Z',
    'key': 'mem.usage',
    'name': 'MEMORY USAGE',
    'metaSensorItemType': {
      'id': 2,
    },
  },
  {
    'id': 4,
    'create_date': '2017-06-26T11:10:08Z',
    'key': 'mem.free',
    'name': 'MEMORY FREE',
    'metaSensorItemType': {
      'id': 2,
    },
  },
];

export default SensorItemTree;
